
#include <Arduino_JSON.h>

const int Relay[6] = {2, 4, 7, 8, 12, 13};
const int Fan[6] = {3, 5, 6, 9, 10, 11};

String inputString = "";        
bool stringComplete = false;
String LastCommand = "";
String Status[6] = {"","","","","",""};

void setup() 
{
  // initialize serial:
  Serial.begin(115200);

  pinMode(Relay[0], OUTPUT);
  pinMode(Relay[1], OUTPUT);
  pinMode(Relay[2], OUTPUT);
  pinMode(Relay[3], OUTPUT);
  pinMode(Relay[4], OUTPUT);
  pinMode(Relay[5], OUTPUT);

  // reserve 200 bytes for the inputString:
  inputString.reserve(200);
}

void loop() {
  
  if (stringComplete) {
    
    
    
    if(inputString.substring(0,6) == "STATUS")
    {      
      JSONVar myArray;

      myArray[0] = analogRead(0);
      myArray[1] = analogRead(1);
      myArray[2] = analogRead(2);
      myArray[3] = analogRead(3);
      myArray[4] = analogRead(4);
      myArray[5] = analogRead(5);      
      myArray[6] = LastCommand;
      myArray[7] = Status;

      inputString = JSON.stringify(myArray);

    }
    else if(inputString.substring(0,6) == "RELAY ")
    {
      int key = getValue(inputString, ' ', 1, 0, 5);
      int value = getValue(inputString, ' ', 2, 0, 1);

      digitalWrite(Relay[key], value);

      Status[key] = inputString.substring(0,6) + " " + key + " " + value;
    }
    else if(inputString.substring(0,7) == "RELAYS ")
    {
      digitalWrite(Relay[0], getValue(inputString, ' ', 1, 0, 1) );
      digitalWrite(Relay[1], getValue(inputString, ' ', 2, 0, 1) );
      digitalWrite(Relay[2], getValue(inputString, ' ', 3, 0, 1) );
      digitalWrite(Relay[3], getValue(inputString, ' ', 4, 0, 1) );
      digitalWrite(Relay[4], getValue(inputString, ' ', 5, 0, 1) );
      digitalWrite(Relay[5], getValue(inputString, ' ', 6, 0, 1) );
      
      Status[0] = getValue(inputString, ' ', 1, 0, 1);
      Status[1] = getValue(inputString, ' ', 2, 0, 1);
      Status[2] = getValue(inputString, ' ', 3, 0, 1);
      Status[3] = getValue(inputString, ' ', 4, 0, 1);
      Status[4] = getValue(inputString, ' ', 5, 0, 1);
      Status[5] = getValue(inputString, ' ', 6, 0, 1);

    }
    else if(inputString.substring(0,4) == "FAN ")
    {
      int key = getValue(inputString, ' ', 1, 0, 5);
      int value = getValue(inputString, ' ', 2, 0, 255);

      analogWrite(Fan[key], value);

      Status[key] = inputString.substring(0,6) + " " + key + " " + value;

    }
    else  if(inputString.substring(0,5) == "FANS ")
    {
      analogWrite(Fan[0], getValue(inputString, ' ', 1, 0, 255) );
      analogWrite(Fan[1], getValue(inputString, ' ', 2, 0, 255) );
      analogWrite(Fan[2], getValue(inputString, ' ', 3, 0, 255) );
      analogWrite(Fan[3], getValue(inputString, ' ', 4, 0, 255) );
      analogWrite(Fan[4], getValue(inputString, ' ', 5, 0, 255) );
      analogWrite(Fan[5], getValue(inputString, ' ', 6, 0, 255) );
      
      Status[0] = getValue(inputString, ' ', 1, 0, 255);
      Status[1] = getValue(inputString, ' ', 2, 0, 255);
      Status[2] = getValue(inputString, ' ', 3, 0, 255);
      Status[3] = getValue(inputString, ' ', 4, 0, 255);
      Status[4] = getValue(inputString, ' ', 5, 0, 255);
      Status[5] = getValue(inputString, ' ', 6, 0, 255);
    }
    
    LastCommand = inputString;
    
    Serial.println(inputString);
    
    inputString = "";
    stringComplete = false;
    
  }//End of if (stringComplete)

}

/*
  SerialEvent occurs whenever a new data comes in the hardware serial RX. This
  routine is run between each time loop() runs, so using delay inside loop can
  delay response. Multiple bytes of data may be available.
*/
void serialEvent() {
  while (Serial.available()) {
    // get the new byte:
    char inChar = (char)Serial.read();
    // add it to the inputString:
    inputString += inChar;
    // if the incoming character is a newline, set a flag so the main loop can
    // do something about it:
    if( (inChar == '\r') || (inChar == '\n') ) {
      stringComplete = true;
    }
  }
}


int getValue(String data, char separator, int index, int imin, int imax)
{
    int found = 0;
    int strIndex[] = { 0, -1 };
    int maxIndex = data.length() - 1;

    for (int i = 0; i <= maxIndex && found <= index; i++) {
        if (data.charAt(i) == separator || i == maxIndex) {
            found++;
            strIndex[0] = strIndex[1] + 1;
            strIndex[1] = (i == maxIndex) ? i+1 : i;
        }
    }
    String sresp =  found > index ? data.substring(strIndex[0], strIndex[1]) : "";

    return constrain(sresp.toInt(), imin, imax);
}
